/**
 * Copyright (C) 2011 Alexander Azarov <azarov@osinka.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.osinka.subset

/** RichString
  */
class FieldBlank(val name: String) {
  class SubsetBlank[Self](self:Self) {
    def of[T] = Subset[T,Self](name, self)
  }

  def fieldOf[T]: Field[T] = Field[T](name)

  def subset[Self](self: Self) = new SubsetBlank[Self](self)
}
